/**********************************************************************************/
/*       									  */
/* Copyright (c) 2002, Analog Devices Inc., All Rights Reserved			  */	
/* api_const.h 									  */
/*										  */
/* This file is part of the "ADI USB ADSL Driver for Linux".			  */	
/*										  */
/* "ADI USB ADSL Driver for Linux" is free software; you can redistribute it      */
/* and/or modify it under the terms of the GNU General Public License as 	  */
/* published by the Free Software Foundation; either version 2 of the License,    */
/* or (at your option) any later version.					  */
/*										  */
/* "ADI USB ADSL Driver for Linux" is distributed in the hope that it will be     */
/* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of	  */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  */
/* GNU General Public License for more details.					  */
/*										  */
/* You should have received a copy of the GNU General Public License		  */
/* along with "ADI USB ADSL Driver for Linux"; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	  */
/**********************************************************************************/

#ifndef API_CONST_H
#define API_CONST_H

#define API_DEFAULT_RETURN_VALUE	0

enum	_API_DEVICES
{
	API_DEVICE_NOTDETECTED, 
	API_DEVICE_USB,
	API_DEVICE_ETHERNET
};

// API ERROR Codes

typedef enum	
{
	API_RETURN_SUCCESS,
	API_RETURN_FUNC_NOTSUPPORTED,
	API_RETURN_HARDWARE_ERROR,	// Hardware or Firmware Error
	API_RETURN_COMM_ERROR,		// Error in opening a communication channel. (Sending Control Codes)
	API_RETURN_PENDINGCALL_ERROR, // The previous API Call is still pending.
	API_RETURN_FUNC_INPUT_ERROR, // API function is called with invalid input.
	API_SOCKET_ERROR,
	API_RECEIVE_TIMEOUT_ERROR,
	API_ETH_RECEIVE_ERROR,
        API_RETURN_MODEMBOOTING_ERROR,
        API_RETURN_CMVDECODE_ERROR 
} _API_RETURN_CODES;


enum	_API_FUNCTION_CODES
{

	API_LIB_RELEASE_VERSION			= 200,
	API_DRIVER_VERSION				,
	API_FIRMWARE_VERSION			,
	API_CMV_DSP_VERSION				,

	API_CMV_LINE_RATE				,
	API_CMV_TRANSMIT_LINERATE		,
	API_CMV_RECEIVE_LINERATE		,
	API_CMV_STATUS					,
	API_CMV_MODEM_STATUS			,
	API_CMV_ADSL_STANDARD_READ		,	//STAT 0
	API_CMV_DS_INTERLEAVE_DEPTH		,	// INTL 0
	API_CMV_US_INTERLEAVE_DEPTH		, // INTL 1
	API_CMV_INTL_TRANS_CELLS		,	// DIAG 3
	API_CMV_FAST_TRANS_CELLS		,	// DIAG 4
	API_CMV_INTL_RECEIVED_CELLS		, // DIAG 11
	API_CMV_FAST_RECEIVED_CELLS		, // DIAG 12
	API_CMV_CRC_NE					, // DIAG 22
	API_CMV_CRC_FE					, // DIAG 46
	API_CMV_FEC_NE					, // DIAG 54
	API_CMV_FEC_FE					, // DIAG 58
	API_CMV_NE_SNR_MARGIN			, // DIAG 25  
	API_CMV_FE_SNR_MARGIN			,	// DIAG 49 
	API_CMV_NE_ATTENUATION			, // DIAG 23
	API_CMV_FE_ATTENUATION			, // DIAG 47
	API_CMV_DELINEATION				,	// DIAG 9
	API_CMV_ATMCELL_INTLTX			, // DIAG 7
	API_CMV_ATMCELL_FASTTX			, // DIAG 8
	API_VPI_RW						,
	API_VCI_RW						,
	API_ENCAPSULATION_TYPE_RW		,
	API_CMV_LASTFAILED_STATUS		,	// STAT 0
	API_CMV_DS_CONN_TYPE			,	// CODE 0
	API_CMV_US_CONN_TYPE			, // CODE 1
	API_CMV_FRAME_OVERHEAD			, // OPTN 2
	API_CMV_TRELLIS_ENCODING		, // OPTN 0
	API_CMV_CO_VENDOR_ID			, // INFO 14
	API_CMV_RT_VENDOR_ID			, // INFO 13
	API_F4_SEGMENT					,
	API_F4_ENDTOEND					,
	API_F5_SEGMENT					,
	API_F5_ENDTOEND					,
	API_CMV_BIN_TEST				,	// TEST 0
	API_MODEM_TEST					,
	API_CODE_VERSION				,
	API_MAC_ADDRESS					,
	API_MODEM_SKU_NO				,
	API_CMV_RESTART_DSL				,	// CNTL 0 
	API_OAM_LOOPBACK_COUNTER		,
	API_CMV_US_BIN_LOADING			,
	API_CMV_DS_BIN_LOADING			,
	API_CMV_SNR_PER_BIN				,
	API_CMV_ADSL_STANDARD_WRITE		,	// optn 4
	API_CMV_DELINEATION_LATCHED		, // Diag 10
	API_CMV_ATMCELL_DROPPED_INTRL	,	// DIAG 19
	API_CMV_ATMCELL_DROPPED_FAST	, // DIAG 20
	API_OAM_RESET_COUNTERS

};

// API Return values
enum	_API_MODEM_STATUS
{
	API_MODEM_STATUS_IDLE,			
	API_MODEM_STATUS_INITIALIZING,	
	API_MODEM_STATUS_OPERATIONAL,
	API_MODEM_STATUS_FAIL,
	API_MODEM_STATUS_TEST_SIGNAL
};


enum	_API_RD_ADSL_STANDARD
{
	API_RD_ADSL_STANDARD_T1413	= 0x0200, 
	API_RD_ADSL_STANDARD_GDMT	= 0x0210,
	API_RD_ADSL_STANDARD_GLITE	= 0x4210
};

enum	_API_WR_ADSL_STANDARD
{
	API_WR_ADSL_STANDARD_T1413		= 0x2 ,
	API_WR_ADSL_STANDARD_GDMT		= 0x11,
	API_WR_ADSL_STANDARD_GLITE		= 0x21,
	API_WR_ADSL_STANDARD_MULTIMODE	= 0x0		
};

enum	_API_MODEM_TEST_RESULT
{
	API_MODEM_TEST_PASS,		
	API_MODEM_TEST_FAILURE
};

enum	_API_MODEM_LAST_FAILD_STATUS
{
	API_FAILSTAT_RESET_REQUESTED = 1,	// User/Gui requested reset
	API_FAILSTAT_CO_RESET,			// Co Dropped the line
	API_FAILSTAT_BAD_STATCMV,		// (RT Dropped the line) Invalid Stat CMV result 
	API_FAILSTAT_MODEM_NOREPLY,		// (RT Dropped the line) There was no reply from Modem 
	API_FAILSTAT_MODEM_BADREPLY,	// (RT Dropped the line) Modem Invalid reply
	API_FAILSTAT_MODEM_LOS,			// (RT Dropped the line) Got Loss of Signal
	API_FAILSTAT_MODEM_NOISE,		// (RT Dropped the line) CRC 
	API_FAILSTAT_MODEM_LEFT_OP,		// (RT Dropped the line) Modem left operational state
	API_FAILSTAT_HW_SIGNAL_TEST,	// (RT Dropped the line) Modem got stuck in test mode
	API_FAILSTAT_MODEM_TRAIN_FAIL,	// (RT Dropped the line) Modem failed to train
	API_FAILSTAT_MODEM_LONG_INIT,	// (RT Dropped the line) Modem stuck in initializing state
	API_FAILSTAT_MODEM_UNKNOWN		// Line was dropped !!!
};


enum	_ENCAPSULATION
{
	API_BRIDGED_LLC_SNAP,
	API_BRIDGED_VC_MUX,
	API_ROUTED_LLC_SNAP,
	API_ROUTED_VC_MUX
};

enum	_API_CONN_TYPE
{
	API_CONN_TYPE_INTERLEAVED,		
	API_CONN_TYPE_FAST,
	API_CONN_TYPE_NOTDETECTED
};

enum	_API_FRAME_MODE
{
	API_FRAME_MODE_0,
	API_FRAME_MODE_1,
	API_FRAME_MODE_2,
	API_FRAME_MODE_3
};

enum	_API_TESTTONE
{
	API_STOPSEND_TESTTONE			= 0x00,
	API_TX_TESTTONE					= 0x01,
	API_TX_WIDEBAND_TESTTONE		= 0x02
};

enum	_API_DELINEATION
{
	API_DELINEATION_GOOD,		
	API_DELINEATION_BAD	
};

enum	_API_BIN_NUMBERS
{
	API_US_NUMOFBINS		=31,
	API_US_BIN0_OFFSET		= 0,
	API_US_BIN30_OFFSET     = 30,
	API_DS_NUMOFBINS		= 225,
	API_DS_BIN31_OFFSET		= 63,
	API_DS_BIN255_OFFSET    = 287	
};

enum _API_TRELLIS
{
	API_TRELLIS_ENCODING_OFF,
	API_TRELLIS_ENCODING_ON
};


typedef struct
{
	UINT transmitSignalType; 
	UINT binNumber;
	UINT tonePower;
	UINT widebandPower;

} BINTEST_COMMAND, *PBINTEST_COMMAND;

typedef struct
{
	union 
	{
		DWORD		dwValue;
		FLOAT		fValue;	
		BINTEST_COMMAND	binTestCmd;
	}; 

} API_COMM_BUFFER, *PAPI_COMM_BUFFER;

typedef struct
{

	ULONG OAM_F4_SegmentRepliesCPE;
	ULONG OAM_F4_EndToEndRepliesCPE;
	ULONG OAM_F5_SegmentRepliesCPE;
	ULONG OAM_F5_EndToEndRepliesCPE;

	ULONG OAM_F4_SegmentRequestsCPE;
	ULONG OAM_F4_EndToEndRequestsCPE;
	ULONG OAM_F5_SegmentRequestsCPE;
	ULONG OAM_F5_EndToEndRequestsCPE;

	ULONG OAM_F4_SegmentRepliesCO;
	ULONG OAM_F4_EndToEndRepliesCO;
	ULONG OAM_F5_SegmentRepliesCO;
	ULONG OAM_F5_EndToEndRepliesCO;

} API_OAM_COUNTERS, *PAPI_OAM_COUNTERS;

#endif




