/**********************************************************************************/
/*										  */
/* Copyright (c) 2002, Analog Devices Inc., All Rights Reserved			  */	
/* driver_access.h 								  */
/*										  */
/* This file is part of the "ADI USB ADSL Driver for Linux".			  */	
/*										  */
/* "ADI USB ADSL Driver for Linux" is free software; you can redistribute it      */
/* and/or modify it under the terms of the GNU General Public License as 	  */
/* published by the Free Software Foundation; either version 2 of the License,    */
/* or (at your option) any later version.					  */
/*										  */
/* "ADI USB ADSL Driver for Linux" is distributed in the hope that it will be     */
/* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of	  */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  */
/* GNU General Public License for more details.					  */
/*										  */
/* You should have received a copy of the GNU General Public License		  */
/* along with "ADI USB ADSL Driver for Linux"; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	  */
/**********************************************************************************/


#ifndef DRIVER_ACCESS_H
#define DRIVER_ACCESS_H

#include "api_const.h"
#include "drv_access.h"

#define	BIT_FPGA_FILEREAD_SUCCESS		0x00000001
#define BIT_CMVTXT_FILEREAD_SUCCESS		0x00000002
#define BIT_BNM_FILEREAD_SUCCESS		0x00000004



#define BIT_SM_RT_RESET					0x00000001 // RESET requeseted to driver.
#define BIT_SM_CO_RESET					0x00000002 // CO dropped the line.

#define BIT_SM_INVALID_STAT0			0x00000003 // stat0 returned invalid status
#define BIT_SM_MODEM_NOREPLY			0x00000004 // no reply to cmv ..
#define BIT_SM_MODEM_BADREPLY			0x00000005 // bad reply to cmv 

#define BIT_SM_MODEM_LOS				0x00000006 // got loss of signal LOS

#define BIT_SM_MODEM_NOISE				0x00000007 // Noise (CRC )
#define BIT_SM_OUT_OPERATIONAL			0x00000008 // Modem went out of operational state -> reset
#define BIT_SM_HW_SIGNAL_STATE			0x00000009 // SM was enabled and STAT0 reported HW/Signal state
#define BIT_SM_MODEM_TRAIN_FAIL			0x0000000A // Modem Failed to train.
#define BIT_SM_MODEM_LONG_INIT			0x0000000B	// locked in INITIALIZING ....



#define UNIQUE_ID_SIZE				7		// should be double checked. (comes from driver)

#define	CMV_READ_COMMAND	"cr"
#define CMV_WRITE_COMMAND	"cw"
#define ADICMV_ENABLE_SM	0
#define ADICMV_DISABLE_SM	4

//LINK_INFO AdicmvLink;
typedef struct  // Input Values for the CMV dialog
{
	CString sOffSet;
	CString sValue;
	CString sCMV;
	CString sMessage;
} _CMV_COMMAND;

#define RESP_OUT_MSG_SIZE 150
#define MAX_OFFSET_SIZE   10
#define MAX_VALUE_SIZE    10
#define MAX_CMV_SIZE      10

typedef struct  // Response Values for the CMV dialog
{
	UCHAR   sOffSet[MAX_OFFSET_SIZE];
	UCHAR   sValue[MAX_VALUE_SIZE];
	DWORD	iValue;
	UCHAR   sCMV[MAX_CMV_SIZE];
	UCHAR   sMessage[RESP_OUT_MSG_SIZE];
	UINT	iReturnCode;
} _ADICMV_RESPONSE;

typedef _ADICMV_RESPONSE ADICMV_RESPONSE;
typedef _CMV_COMMAND CMV_COMMAND;


int AdicmvIOCTLCommand (
	PVOID pBuffer 
);

int AdiIOCTLCommand (
        DWORD code,
	PVOID pBuffer 
);
HANDLE DetectDriver( void ) ;
void CMVReadWrite
(
	CString sReadWrite, 
	CMV_COMMAND GUICommand, 
	ADICMV_RESPONSE *pDriverResponse
);

typedef struct
{
   UInt32  Addr;
   UInt8   Value;
   UInt8   ReturnValue;
} UserDspRWInf;

													//													//
typedef struct {		
  UInt16  VPI;	
  UInt16  VCI;			
  UInt16  Encapsulation;	
}  ParamReadType;		

UINT	AdiAPIFunctionRead(int funcCode, PAPI_COMM_BUFFER pCommBuffer);
UINT	AdiAPIFunctionWrite(int funcCode, const API_COMM_BUFFER *buf);
UINT	AdiLineRate(DWORD *pReturnValue);
UINT	AdiReadSTAT0(DWORD *pReturnValue);
UINT	AdiReadSTAT1(DWORD *pReturnValue);
UINT	GetConnType(DWORD *CodeCmvReturn);


UINT	DMTTimeWrite( const DWORD *dwTime);
UINT	DMTTimeRead ( DWORD *pReturnValue);
UINT	DSPMemoryWrite(const DWORD dwAddress, DWORD dwValue);
UINT	DSPMemoryRead (const DWORD dwAddress, DWORD *pReturnValue);
UINT	ReadGeneralPurposeRegister(UINT *pReturnValue);
UINT	WriteGeneralPurposeRegister(UINT dwValue);
UINT    SetModemState(UINT State);
UINT    GetModemState(UINT *State);

BOOLEAN IsUSBModemConnected(void);
extern BOOLEAN InitETHBridge(void);
#endif











