/**********************************************************************************/
/*										  */
/* Copyright (c) 2002, Analog Devices Inc., All Rights Reserved			  */	
/* drv_access.h 								  */
/*										  */
/* This file is part of the "ADI USB ADSL Driver for Linux".			  */	
/*										  */
/* "ADI USB ADSL Driver for Linux" is free software; you can redistribute it      */
/* and/or modify it under the terms of the GNU General Public License as 	  */
/* published by the Free Software Foundation; either version 2 of the License,    */
/* or (at your option) any later version.					  */
/*										  */
/* "ADI USB ADSL Driver for Linux" is distributed in the hope that it will be     */
/* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of	  */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  */
/* GNU General Public License for more details.					  */
/*										  */
/* You should have received a copy of the GNU General Public License		  */
/* along with "ADI USB ADSL Driver for Linux"; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	  */
/**********************************************************************************/

#ifndef DRV_ACCESS_H
#define DRV_ACCESS_H


UINT	AdiDetectDevice(void);

CString	AdiAPIGetVersion(int SoftwareCode);
CString AdiAPILibReleaseDate(void);

UINT	AdiAPIMacAddress(UCHAR *u64MacAddress, UCHAR *sMac);
UINT	AdiDriverSoftEnumeration(int);


// returns both Link Status and ADSL Standard
UINT	AdiReadModemStatus(DWORD *pLinkStatus, DWORD *pAdslStandard);

// writes both vpi and vci with one single call
UINT	AdiWriteATMVPIVCI(const DWORD *dwVPI, const DWORD *dwVCI);


UINT	AdiReadDspVersion(DWORD *pReturnValue);
UINT	AdiReadTransmitLineRate(DWORD *pLineRate);
UINT    AdiReadLineRates(DWORD *pLineRate);
UINT	AdiReadReceiveLineRate(DWORD *pLineRate);
UINT	AdiReadLinkStatus(DWORD *pLinkStatus);
UINT	AdiWriteAdslStandard(DWORD dwAdslStandard);
UINT	AdiReadADSLStandard(DWORD *pAdslStandard);

UINT	AdiReadDSInterleaveDepth(DWORD *pReturnValue);
UINT	AdiReadUSInterleaveDepth(DWORD *pReturnValue);

UINT	AdiReadInterleavedTransmittedCells(DWORD *pReturnValue);
UINT	AdiReadFastTransmittedCells(DWORD *pReturnValue);

UINT	AdiReadInterleavedReceivedCells(DWORD *pReturnValue);
UINT	AdiReadFastReceivedCells(DWORD *pReturnValue);

UINT	AdiReadNearEndCRC(DWORD *pReturnValue);
UINT	AdiReadFarEndCRC(DWORD *pReturnValue);

UINT	AdiReadNearEndFEC(DWORD *pReturnValue);
UINT	AdiReadFarEndFEC(DWORD *pReturnValue);

UINT	AdiReadNearEndSNRMargin(FLOAT *pfReturnValue);
UINT	AdiReadFarEndSNRMargin(FLOAT *pfReturnValue);

UINT	AdiReadNearEndAttenuation(FLOAT *pfReturnValue);
UINT	AdiReadFarEndAttenuation(FLOAT *pfReturnValue);

UINT	AdiReadDelineation(DWORD *pReturnValue);


UINT	AdiReadATMCellsDropped_INTRL(DWORD *pReturnValue);
UINT	AdiReadATMCellsDropped_FAST(DWORD *pReturnValue);

UINT	AdiOAMResetCounters(void);
UINT	AdiOAMReadCounters(API_OAM_COUNTERS *oamBuff);

UINT	AdiReadATMVCI(DWORD *pReturnValue);
UINT	AdiReadATMVPI(DWORD *pReturnValue);

UINT	AdiWriteATMVCI(const DWORD *dwVCI);
UINT	AdiWriteATMVPI(const DWORD *dwVPI);

UINT	AdiReadEncapsulationType(DWORD *pEncap);
UINT	AdiWriteEncapsulationType(const DWORD *dwEncap);

UINT	AdiReadModemLastFailedStatus(DWORD *pReturnValue);


UINT	AdiReadDSConnectionType(DWORD *pReturnValue);
UINT	AdiReadUSConnectionType(DWORD *pReturnValue);

UINT	AdiReadFramingMode(DWORD *pReturnValue);

UINT	AdiReadTrellisEncoding(DWORD *pReturnValue);

UINT	AdiReadCOVendorID(DWORD *pReturnValue);
UINT	AdiReadRTVendorID(DWORD *pReturnValue); 



UINT	AdiSetModemTestSignalState(void);
UINT	AdiSetModemNormalState(void);
UINT	AdiDisableStateMachine(void);
UINT	AdiEnableStateMachine(void);
UINT	AdiControlBinTest(const BINTEST_COMMAND	*binTestCmd); // start/stop test.
UINT	AdiReadBinPower(UINT binNum, DWORD *pReturnValue); // reads the power 


UINT	AdiModemSelfTest(DWORD *pTestResult);

UINT	AdiUSBinLoading(UINT uiBin, DWORD *pNumBitPerFrame);
UINT	AdiDSBinLoading(UINT uiBin, DWORD *pNumBitPerFrame, FLOAT *pSNR, FLOAT *pGain);

UINT	AdiRestartDSLConnection(void);
UINT	AdiModemHardReset(void);


UINT	AdiAPIFunctionRead( int funcCode,PAPI_COMM_BUFFER pCommBuffer);
UINT	AdiAPIFunctionWrite(int funcCode, const API_COMM_BUFFER *buf);

UINT	AdiDriverResetLinkBaseCntrs(void);

UINT	AdiAPICmvRead(UCHAR *Comm,UCHAR *Offset,DWORD *pReturnValue);
UINT	AdiAPICmvWrite(UCHAR *Comm,UCHAR *Offset, UCHAR *Value,DWORD *pReturnValue);


UINT AdiReadVPI(DWORD *dwValue);
UINT AdiReadVCI(DWORD *dwValue);
UINT AdiReadEncapsulation(DWORD *dwValue);
UINT AdiReadLineType(DWORD *pReturnValue);
#endif








