/**********************************************************************************/
/*										  */
/* Copyright (c) 2002, Analog Devices Inc., All Rights Reserved			  */	
/* looptest.h 									  */
/*										  */
/* This file is part of the "ADI USB ADSL Driver for Linux".			  */	
/*										  */
/* "ADI USB ADSL Driver for Linux" is free software; you can redistribute it      */
/* and/or modify it under the terms of the GNU General Public License as 	  */
/* published by the Free Software Foundation; either version 2 of the License,    */
/* or (at your option) any later version.					  */
/*										  */
/* "ADI USB ADSL Driver for Linux" is distributed in the hope that it will be     */
/* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of	  */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  */
/* GNU General Public License for more details.					  */
/*										  */
/* You should have received a copy of the GNU General Public License		  */
/* along with "ADI USB ADSL Driver for Linux"; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	  */
/**********************************************************************************/


#include "linuxusbapi.h"

int main(void)
{
 UINT ret;
 DWORD dwValue;
 pid_t id;
 char pr[10];

 printf ("This program will fork another process and both get Stat0 and Stat1 registers in an unlimited loop to test multi process aceess to kernel IO buffers in a loop. You may exit by pressing Ctrl-C\n\n");

 //while (getchar()!=10);

 id = fork();

 strcpy(pr,id==0 ? "Child ->":"Parent->");
 printf("%s Started!\n",pr);

 while (!AdiDetectDevice());

 while (1) {
   if (AdiDetectDevice())
   {
     ret = AdiReadSTAT0(&dwValue); 
     if (ret==API_RETURN_SUCCESS)
       printf("%s Success stat0:%lx\n",pr,dwValue);
     else printf("%s Error in Getting Stat0 %d\n",pr,ret);

     ret = AdiReadSTAT1(&dwValue); 
     if (ret==API_RETURN_SUCCESS)
       printf("%s Success stat1:%ld\n",pr,dwValue);
     else printf("%s Error in Getting Stat1 %d\n",pr,ret);
   }
 }
 return 1;
}





















