/**********************************************************************************/
/*										  */
/* Copyright (c) 2002, Analog Devices Inc., All Rights Reserved			  */	
/* mlcc.h 									  */
/*										  */
/* This file is part of the "ADI USB ADSL Driver for Linux".			  */	
/*										  */
/* "ADI USB ADSL Driver for Linux" is free software; you can redistribute it      */
/* and/or modify it under the terms of the GNU General Public License as 	  */
/* published by the Free Software Foundation; either version 2 of the License,    */
/* or (at your option) any later version.					  */
/*										  */
/* "ADI USB ADSL Driver for Linux" is distributed in the hope that it will be     */
/* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of	  */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  */
/* GNU General Public License for more details.					  */
/*										  */
/* You should have received a copy of the GNU General Public License		  */
/* along with "ADI USB ADSL Driver for Linux"; if not, write to the Free Software */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA	  */
/**********************************************************************************/

#ifndef _MLCC
#define _MLCC

#define UINT unsigned int
#define MLCC_MAJOR_VERSION				1	
#define MLCC_MINOR_VERSION				2	

#define ML_CMD_ETH_TYPE					0x00FF	

#define MAX_CONNECTIONS					8	
#define MAX_NAT_ENTRIES					1
#define MAX_MODEMS						1

#define CC_SUCCESS_ERROR				0
#define CC_ALREADY_CONNECTED_ERROR		1
#define CC_MAX_CONNECTION_ERROR			2
#define CC_SP_PARAMETER_ERROR			3
#define CC_SP_NOTCONNECTED_ERROR		4
#define CC_UNSYNC_ERROR					5 
#define CC_ALREADY_INITIALIZED_ERROR	6
#define CC_IO_REQUEST_ERROR				7
#define CC_INVALID_TD_HANDLE_ERROR		8
#define CC_NOT_ENOUGHMEMORY_ERROR		9
#define CC_NO_CCHANDLE_ERROR			0xA
#define	CC_GET_FILE_NAME_ERROR			0xB	
#define CC_MEMORY_ALLOC_ERROR          	0xC	
#define CC_RASOPEN_ERROR				0xD	
#define CC_RASCLOSE_ERROR				0xE	
#define CC_MODEM_INIT_ERROR				0xF	
#define CC_SP_ALREADY_CONNECTED_ERROR	0x10    
#define CC_PPP_NOTSUPPORTED_ERROR		0x11    
#define CC_NOT_SUCCESS_ERROR			0x12  
#define CC_TAPIDEVSPECIFIC_ERROR		0x13  
#define CC_TAPILINEOPEN_ERROR			0x14  
#define CC_PENDING_CMV_ERROR			0x15	

#define CC_TRIGGER_NO_ERROR				0xE0	
#define CC_TRIGGER_MODEM_UNSYNC			0xE1	

#define CC_NOT_SUPPORTED_ERROR			0xFF	

#define	CC_RESET_LINKSTAT				0
#define	CC_GET_LINKSTAT					1

#define CC_SET_LINKPARAM				0
#define CC_GET_LINKPARAM				1

#define CC_RESET_TOTALSTAT				0	
#define CC_GET_TOTALSTAT				1

#define CC_SET_MODEMPARAM				0
#define CC_GET_MODEMPARAM				1

#define CC_RESET_MODEMSTAT				0
#define CC_GET_MODEMSTAT				1


#define TEM_ACTIVATE_CONNECTION			1
#define TEM_DEACTIVATE_CONNECTION		2
#define TEM_GET_LINKSTATUS				3
#define TEM_RESET_LINKSTATUS			4
#define TEM_SET_LINKPARAMETERS			5
#define TEM_GET_LINKPARAMETERS			6
#define TEM_GET_TOTALSTATUS				7
#define TEM_RESET_TOTALSTATUS			8
#define TEM_GET_DRIVERVERSION			9
#define TEM_SET_NAT						10
#define	TEM_GET_NAT						11
#define	TEM_SET_DHCP					12
#define	TEM_GET_DHCP					13
#define	TEM_SET_MODEMPARAMETERS			14
#define	TEM_GET_MODEMPARAMETERS			15
#define	TEM_GET_MODEMSTATUS				16
#define	TEM_RESET_MODEMSTATUS			17
#define TEM_RESET_CONNECTIONS			18 
#define TEM_TRIGGER_ON_ERROR			19 
#define TEM_GET_DATE					20
#define TEM_GET_TIME					21


#define TEM_SHOW_PCI					24 
#define TEM_WRITE_PCI					25 
#define TEM_SUSPEND_DRIVER				26 

#define TEM_READ_EEPROM					27 
#define TEM_WRITE_EEPROM				28 
#define TEM_WRITE_PCI_CONFIG    		29

#define TEM_STORE_FILE_CMV      		30 
#define TEM_RESET_CMV           		31 

#define TEM_TOGGEL_DIULUP				40 
#define TEM_DISCONNECT_DIALUP			41 

#define TEM_DRIVER_STATUS				51 
#define TEM_DRIVER_CMD					52 
#define TEM_SPECIAL_CMD					53 

#define TEM_READ_OAM_COUNTERS			60 
#define TEM_CLEAR_OAM_COUNTERS			61 
#define TEM_OAM_INITIATE_F5E			62 
#define TEM_OAM_INITIATE_F5S			63 
#define TEM_OAM_INITIATE_F4E			64 
#define TEM_OAM_INITIATE_F4S			65 

#define TEM_CA_INFOTEST					90 
#define TEM_CA_GET_PERF					91
#define TEM_CA_RESET_PERF				92

#define TEM_ADI_CMV						0xD0 
#define TEM_ADI_MODEM_RESET				0xD1 
#define TEM_ADI_MODEM_MEMR				0xD2 
#define TEM_ADI_MODEM_MEMW				0xD3 
#define TEM_ADI_MODEM_GPR				0xD4 
#define TEM_ADI_MODEM_GPW				0xD5 

#define TEM_ADI_MODEM_ZZ				0xD6 
#define TEM_ADI_DEVSPEC_READ			0xD7 
#define TEM_ADI_DEVSPEC_WRITE			0xD8 
#define TEM_ADI_SOFT_ENUM				0xD9 

#define TEM_ADI_DMT_READ				0xDA 
#define TEM_ADI_DMT_WRITE				0xDB 
#define TEM_ADI_DRV_STATEREG_READ		0xDC 
#define TEM_ADI_DRV_STATEREG_WRITE		0xDD 
#define TEM_ADI_DRV_ERRORREG_READ		0xDE 
#define TEM_ADI_DRV_ERRORREG_WRITE		0xDF 


#define TEM_GET_ASIC_PARAMS				0xE0
#define TEM_TEST_DISABLE_ASICFRAMER		0xE1
#define TEM_TEST_ASIC_RAM				0xE2
#define TEM_TEST_TOGGLE_LED				0xE3
#define TEM_TEST_XCVR_ID				0xE4
#define TEM_TEST_FPGA_ID				0xE5
#define TEM_TEST_ENABLE_TIMER			0xE6
#define TEM_TEST_DISABLE_TIMER			0xE7
#define TEM_TEST_RESET_MODEM			0xE8

#define TEM_GET_MAC_ADDESS				0xE9 
#define TEM_ADI_DRV_SM_INFOREG_READ     0xEA 
#define TEM_ADI_DRV_SM_INFOREG_WRITE	0xEB 
#define TEM_GET_DRIVER_STATS			0xEC 
#define TEM_RESET_LINKBASE_CNTRS		0xED 



#define TEM_DMT_GET_MODEM				0x200
#define TEM_DMT_GET_ADSL_LINE_TYPE		0x201
#define TEM_DMT_GET_DMTDownRate			0x202
#define TEM_DMT_GET_DMTUpRate			0x203
#define TEM_DMT_GET_DMTTime				0x204
#define TEM_DMT_GET_ADPT0				0x205
#define TEM_DMT_GET_ADPT1				0x206
#define TEM_DMT_GET_CNTL0				0x207
#define TEM_DMT_GET_OPTN0				0x208
#define TEM_DMT_GET_OPTN2				0x209
#define TEM_DMT_GET_OPTN4				0x20A
#define TEM_DMT_GET_OPTN5				0x20B
#define TEM_DMT_GET_PSDM0				0x20C
#define TEM_DMT_GET_PSDM1				0x20D
#define TEM_DMT_GET_PFCL1				0x20E
#define TEM_DMT_GET_ISDN				0x20F
#define TEM_DMT_GET_UNH					0x210
#define TEM_DMT_GET_Decode				0x211
#define TEM_DMT_GET_BMODE				0x212
#define TEM_DMT_GET_PrintTime			0x213
#define TEM_DMT_GET_Timerflag			0x214
#define TEM_DMT_GET_msp930				0x215
#define TEM_DMT_GET_ADPT2				0x216
#define TEM_DMT_GET_INFO09				0x217
#define TEM_DMT_GET_MAX_CRC				0x218

#define TEM_DMT_SET_MODEM				0x300
#define TEM_DMT_SET_ADSL_LINE_TYPE		0x301
#define TEM_DMT_SET_DMTDownRate			0x302
#define TEM_DMT_SET_DMTUpRate			0x303
#define TEM_DMT_SET_DMTTime				0x304
#define TEM_DMT_SET_ADPT0				0x305
#define TEM_DMT_SET_ADPT1				0x306
#define TEM_DMT_SET_CNTL0				0x307
#define TEM_DMT_SET_OPTN0				0x308
#define TEM_DMT_SET_OPTN2				0x309
#define TEM_DMT_SET_OPTN4				0x30A
#define TEM_DMT_SET_OPTN5				0x30B
#define TEM_DMT_SET_PSDM0				0x30C
#define TEM_DMT_SET_PSDM1				0x30D
#define TEM_DMT_SET_PFCL1				0x30E
#define TEM_DMT_SET_ISDN				0x30F
#define TEM_DMT_SET_UNH					0x310
#define TEM_DMT_SET_Decode				0x311
#define TEM_DMT_SET_BMODE				0x312
#define TEM_DMT_SET_PrintTime			0x313
#define TEM_DMT_SET_Timerflag			0x314
#define TEM_DMT_SET_msp930				0x315
#define TEM_DMT_SET_ADPT2				0x316
#define TEM_DMT_SET_INFO09				0x317
#define TEM_DMT_SET_MAX_CRC				0x318
#define TEM_DMT_GEN_MP_CMVs				0x3FF

#define TEM_DRIVER_GET_DebugFlag		0x400
#define TEM_DRIVER_GET_DebugFlags		0x401
#define TEM_DRIVER_GET_DebugLevel		0x402

#define TEM_DRIVER_SET_DebugFlag		0x500
#define TEM_DRIVER_SET_DebugFlags		0x501
#define TEM_DRIVER_SET_DebugLevel		0x502

#define TEM_ATM_GET_VCI_VPI				0x600
#define TEM_ATM_GET_ENCAPSULATION		0x601
#define TEM_ATM_GET_RX_PPP_SERVER_TYPE	0x602
#define TEM_ATM_GET_TX_PPP_SERVER_TYPE	0x603

#define TEM_ATM_SET_VCI_VPI				0x700
#define TEM_ATM_SET_ENCAPSULATION		0x701
#define TEM_ATM_SET_RX_PPP_SERVER_TYPE	0x702
#define TEM_ATM_SET_TX_PPP_SERVER_TYPE	0x703



#define CC_ATM 0x1
#define CC_FR  0x2
#define CC_HDLC 0x3

#define CC_ETHERNET 0x10
#define CC_PPP      0x20
#define CC_IP	 0x30

#define CC_ETHERNET_ATM (CC_ETHERNET | CC_ATM )
#define CC_ETHERNET_FR  (CC_ETHERNET | CC_FR	 )
#define CC_ETHERNET_HDLC (CC_ETHERNET| CC_HDLC )

#define CC_PPP_ATM  (CC_PPP | CC_ATM )
#define CC_PPP_FR   (CC_PPP | CC_FR )
#define CC_PPP_HDLC (CC_PPP | CC_HDLC )

#define CC_IP_ATM  (CC_IP | CC_ATM)
#define CC_IP_FR   (CC_IP | CC_FR)	 

#define CA_INFOTEST_RES1	0x2
#define CA_INFOTEST_RES2	0x3
#define CA_INFOTEST_RES3	0x7
#define CA_INFOTEST_RES4	0x5

#define MAX_LINE_LEN    80 
#define MAX_CMV_LEN     4 
#define MAX_OFFSET      0xFFFF
#define MAX_CMV_COUNT   25 

#define CMV_MESSAGE_SIZE 8


typedef enum {CONNECTED, DISCONNECTED} LINK_STATE;

typedef enum {AAL5UBR,AAL5ABR,AAL1,AAL2,AAL3,AAL4,AALX,Null} CONN_TYPE;
typedef	enum {GTI_RADSL, ALCATEL_DMT, DLCC_RADSL, HDSL} MODEM_VERSION;
typedef enum {CELL,FRAME} CONN_MODE;


typedef enum {SYNC1,UNSYNC1} MODEM_STATUS;  

typedef enum {G_LITE, G_DMT, T1_413, MULTI_MODE, UTOPIA, DEFAULT} ADSL_LINE_TYPE;  
typedef enum {CO1, RT1} MODEM;  

typedef enum {RFC1483_BRIDGE=0, RFC1483_ROUTED=1, RFC2346_NONE=0, RFC2346_LLC=1} ENCAPSULATION;  
typedef enum {RXFF03_NULL, RXFF03_REMOVE, RXFF03_ADD} RX_PPP_SERVER_TYPE;  
typedef enum {TXFF03_NULL, TXFF03_REMOVE, TXFF03_ADD} TX_PPP_SERVER_TYPE;  



typedef struct
{
	unsigned int DebugFlag;
	unsigned int DebugFlags;
	unsigned int DebugLevel;
} ML_DRIVER, *PML_DRIVER;


typedef struct
{
	MODEM Modem;
	ADSL_LINE_TYPE ADSL_LineType;
    UINT    DMTDownRate;
    UINT    DMTUpRate;
    UINT    DMTTime;
    UINT    PrintTime;
    UINT    Timerflag;
	UINT    msp930;
	UINT	MaxCRC;

	UINT    ADPT0;
	UINT    ADPT1;
	UINT    CNTL0;
	UINT    OPTN0;
	UINT    OPTN2;	
	UINT    OPTN4;	
	UINT    OPTN5;	
	UINT    PSDM0;	
	UINT	PSDM1;
	UINT	ADPT2;
	UINT	INFO09;

	UINT    PFCL1;	
    UINT    ISDN;
    UINT    UNH;
	UINT    Decode;
	UINT    BMODE;
} ML_DMT, *PML_DMT;


typedef struct
{
	unsigned int TxBytes;
	unsigned int RxBytes;
	unsigned int TxPackets;
	unsigned int RxPackets;

} ML_PERF_COUNTS, *PML_PERF_COUNTS;


typedef struct
{
	ML_PERF_COUNTS	MlCmd;
	ML_PERF_COUNTS	MlPkt;
	ML_PERF_COUNTS	Other;

} ML_CA_PERF, *PML_CA_PERF;


typedef struct
{
	unsigned char	EmulateCO;
	unsigned char	GtiMargin;
	unsigned char	GtiBaudValue;
	unsigned char	GtiUpConst;

	unsigned char	GtiDownConst;
	unsigned char	TxBufferNumber;
	unsigned char	TxMCounter;
	unsigned char	TxNCounter;

	unsigned char	SmallFreeBuffNumber;
	unsigned char	LargeFreeBuffNumber;
	unsigned char	AutoStartFlag;
	unsigned char	ucReserved;

	unsigned long	ServerIPAddress;
	unsigned long	AsicConfiguration;
	unsigned long	AsicStatus;
	unsigned long	ulReserved;
	unsigned long	ulReserved2;

} ML_ASIC_PARAMS, *PML_ASIC_PARAMS;

typedef struct
{
	unsigned long ulRes1;
	unsigned long ulRes2;
	unsigned long ulRes3;
	unsigned long ulRes4;

}CA_INFOTEST, *PCA_INFOTEST;

typedef struct
{
	unsigned long PCR;
	unsigned long MBS;	
	unsigned long MCR;
	unsigned long SCR;

} TRAFFIC ;

typedef struct
{
	unsigned long I;
	unsigned long L;
}GCRA;

typedef struct
{    	
	unsigned char VPI;
	unsigned short VCI;
	CONN_TYPE ConnType;
	unsigned char GFC;  
	unsigned char CLP;
	unsigned char PTI;
 	TRAFFIC Traffic ;
 	GCRA   gcra;
} ATM_INFO;

typedef struct
{
	ENCAPSULATION Encapsulation;	
	RX_PPP_SERVER_TYPE RxFF03;		
	TX_PPP_SERVER_TYPE TxFF03;		

} ENCAPSULATION_INFO;

typedef struct 
{
	unsigned long DLCI;
	unsigned char DLCISize;  	
	unsigned char OH; 	
}FR_INFO;

typedef struct
{
	  unsigned long CRCInitValue;
}HDLC_INFO;

typedef struct {
	unsigned char A;
	unsigned char B;
	unsigned char C;
	unsigned char D;
} IP_ADDR;

typedef struct 
{
	unsigned char DHCPFlag;
	IP_ADDR IP;
	IP_ADDR Gateway;
	IP_ADDR Mask;
	IP_ADDR Dns;			
} IP_INFO,*PIP_INFO;

typedef struct 
{
	unsigned long  BytesRx;
	unsigned long  BytesTx;
	unsigned long  CRC;
	unsigned long Overrun;
	unsigned long Underrun;
} PHYSICAL_STAT;

typedef struct
{
	unsigned long	CellsTx;
	unsigned long	CellsRx;
	unsigned long	OAMCells;
	unsigned long	CongestionCount;
	unsigned long	RxPackets;  
	unsigned long	TxPackets;  
	unsigned long	HEC;        
	unsigned long	Dropped;    
	unsigned long	CRC;        
	unsigned long	OverSizePacket;  
} ATM_STAT;


typedef struct
{
	unsigned long	FramesTx;
	unsigned long	FramesRx;
	unsigned long	FramesLoss;
	unsigned long	CongestionCount;
	unsigned long	LMIFrames;
}FR_STAT;
  
typedef struct
{
	PHYSICAL_STAT 	PhysicalStat;
	union {			  
		ATM_STAT	ATMStat;
		FR_STAT     FRStat;

	};
} STAT_INFO, *PSTAT_INFO;

typedef struct
{
	CONN_MODE ConnMode;
	STAT_INFO StatInfo;
	unsigned long ReturnStatus;
} STAT_BUFF,*PSTAT_BUFF;

typedef struct 
{
	unsigned char 	NATFlag;
	unsigned char 	NumberOfEntries;
	IP_ADDR		*Address;
	unsigned long	*PortNumber;
} NAT_INFO,*PNAT_INFO;

typedef struct
{
	MODEM_VERSION   Version;
	unsigned short	TxSpeed;
	unsigned long	RxSpeed;
	MODEM_STATUS	ModemStatus;
} MODEM_INFO, *PMODEM_INFO;

typedef struct
{
	unsigned long	SYNCCount;
	unsigned long	SpeedChangeCount;
	short		SignalStrength;
}MODEM_STAT, *PMODEM_STAT;

typedef struct
{
	unsigned long DDVer;	 
	unsigned long TDVer;	 
	unsigned long DDInfo;	 
	unsigned long TDInfo;	 
}VERSIONS;


typedef struct
{
	unsigned long Software;
	unsigned long Hardware;
	unsigned long Firmware;
	unsigned long Date;
	unsigned long Time;
} SYTEM_VERSIONS;
 
typedef struct 
{
	char PhonebookName[100];
	char EntryName[30];
}PPP_INFO,*PPPP_INFO;


typedef struct
{
	unsigned long Status;
} DRIVER, *PDRIVER;





typedef struct
{
	unsigned char SPNo;
	unsigned char LinkNo;
	unsigned char LinkType;
	unsigned char InfoBits;	
	LINK_STATE    LinkState;
	union 
	{
		ATM_INFO   ATMConnInfo;
		FR_INFO    FRConnInfo;
		HDLC_INFO  HDLCConnInfo;
	};
	IP_INFO		IPInfo;
	PPP_INFO	PPPInfo;
	NAT_INFO	NATInfo;
	MODEM_INFO 	ModemInfo;
	unsigned long	DhcpServer;
	PVOID		TriggerIrp;
	PVOID		TriggerMdl;
	unsigned long   Reserved1;
	unsigned long   Reserved2;

}DD_LINK_INFO, *PDD_LINK_INFO;

typedef struct 
{
	unsigned char cmv[MAX_CMV_LEN+1];
	unsigned long offset;
	unsigned long value;
} CMV_CMD, *PCMV_CMD;

typedef struct {
	unsigned long address;
	unsigned long data;
} PCI_EEPROM;

typedef struct	
{
	ULONG OAM_Cells;
	
	ULONG OAM_F4_SegmentRepliesCPE;
	ULONG OAM_F4_EndToEndRepliesCPE;
	ULONG OAM_F5_SegmentRepliesCPE;
	ULONG OAM_F5_EndToEndRepliesCPE;

	ULONG OAM_F4_SegmentRequestsCPE;
	ULONG OAM_F4_EndToEndRequestsCPE;
	ULONG OAM_F5_SegmentRequestsCPE;
	ULONG OAM_F5_EndToEndRequestsCPE;

	ULONG OAM_F4_SegmentRepliesCO;
	ULONG OAM_F4_EndToEndRepliesCO;
	ULONG OAM_F5_SegmentRepliesCO;
	ULONG OAM_F5_EndToEndRepliesCO;

	ULONG OAM_F4_SegmentRequestsCO;
	ULONG OAM_F4_EndToEndRequestsCO;
	ULONG OAM_F5_SegmentRequestsCO;
	ULONG OAM_F5_EndToEndRequestsCO;

	UINT	OAM_vpi;
	UINT	OAM_vci;

} OAM_COUNTERS, *POAM_COUNTERS;

typedef ULONG VPIVCI; 

typedef	struct {

	
	VPIVCI	VpiVci; 
	ULONG	CellLoss;
	ULONG	TXCellCount;
	ULONG	RXCellCount;
	ULONG	TXPacketCount;
	ULONG	RXPacketCount;
	ULONG	PacketLoss;
	ULONG	PacketCrc;
	ULONG	PacketOversize;
	ULONG	Encapsulation;
	ULONG	RxCellBadVpiVci;
	ULONG	RxCellBadHeader;

	
	UINT	DMT_stats_ES_count;
    UINT	DMT_stats_Cur_Atten;
    UINT	DMT_stats_Cur_SNR;
    UINT	DMT_stats_Rx_Blks;
    UINT	DMT_stats_Tx_Blks;
	UINT	DMT_stats_FE_Uncorr_Blks;
    UINT	DMT_stats_Uncorr_Blks;

	UINT	DMT_stats_Oper_Cnt; 

	
    UINT	DMT_stats_Rx_Blks_last;		
    UINT	DMT_stats_Uncorr_Blks_last;	
	
	BOOLEAN	DMT_stats_Ne_Fast_Lod_Failure;
	BOOLEAN	DMT_stats_Ne_Intl_Lod_Failure;
	BOOLEAN	DMT_stats_Ne_Fast_Hec_Failure;
 	BOOLEAN	DMT_stats_Ne_Intl_Hec_Failure;

} DRIVER_STATS, *PDRIVER_STATS;


typedef struct
{
	char MLID[5];
	unsigned long MessageID;
	unsigned char LinkNo;
	unsigned char LinkType;
	LINK_STATE LinkState ;
	union 
	{	
		ATM_INFO     ATMConnInfo;
		FR_INFO      FRConnInfo;
		HDLC_INFO    HDLCConnInfo; 
		IP_INFO      IPConnInfo;
		STAT_INFO    LinkStat;		 
		NAT_INFO     NATInfo;
		MODEM_INFO   ModemInfo;
    	MODEM_STAT   ModemStat;
		VERSIONS     Version;
		CA_INFOTEST  CaTest;		
		DD_LINK_INFO DdLinkInfo;	
		ML_ASIC_PARAMS  AsicParams;	
		unsigned char	DataBuffer; 	
		ML_CA_PERF   PacketInfo;
		ML_DRIVER	Driver;  
		ML_DMT		DMT;  
		ENCAPSULATION_INFO Encapsulation; 
		SYTEM_VERSIONS SystemVersion;
		CMV_CMD   CmvCmd;
		DRIVER		DeviceDriver;
		PCI_EEPROM      PciEeprom;
		OAM_COUNTERS	Oam; 
		DRIVER_STATS DriverStats; 
	}; 
	PVOID	usbIrp;			
	unsigned long      Reserved1;
	unsigned long      Reserved2;
	unsigned long ReturnStatus;
} LINK_INFO, *PLINK_INFO;

typedef struct
{
  unsigned short   DataBuffer[kCMV_DATA_WORDS];
  UInt16   ReturnStatus;
  UInt32   DataWord;
} API_LINK_INFO;

typedef struct
{
	unsigned char SPNo;
	LINK_STATE LinkState;
	unsigned char  LinkType;
	union 
	{
		ATM_INFO  ATMConnInfo;
		FR_INFO    FRConnInfo;
		HDLC_INFO  HDLCConnInfo;
	};
	PIP_INFO pIPInfo;
	PPPP_INFO pPPPInfo;
	PNAT_INFO pNATInfo;
	PSTAT_INFO pLinkStat;
	unsigned long      Reserved1;
	unsigned long      Reserved2;
	unsigned long ReturnStatus;
}SPLINK_INFO, *PSPLINK_INFO;





void UICallBackFunc(void *);
#endif





